
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>FW:  Nginx模块开发入门 / 憋错料</title>

    <meta name="description" content="FW:  Nginx模块开发入门 前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">FW:  Nginx模块开发入门</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>前言</h1>
<p>Nginx是当前最流行的HTTP Server之一，根据W3Techs的统计，目前世界排名（根据Alexa）前100万的网站中，<a href="http://w3techs.com/technologies/overview/web_server/all" rel="external nofollow noreferrer">Nginx的占有率为6.8%</a>。与Apache相比，<a href="http://www.joeandmotorboat.com/2008/02/28/apache-vs-nginx-web-server-performance-deathmatch/" rel="external nofollow noreferrer">Nginx在高并发情况下具有巨大的性能优势</a>。</p>
<p>Nginx属于典型的微内核设计，其内核非常简洁和优雅，同时具有非常高的可扩展性。Nginx最初仅仅主要被用于做反向代理，后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富，Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任，例如目前淘宝内各个部门正越来越多使用Nginx取代Apache，据笔者了解，在腾讯和新浪等公司也存在类似情况。</p>
<p>同时，大量的第三方扩展模块也令Nginx越来越强大。例如，由淘宝的工程师清无（王晓哲）和春来（章亦春）所开发的<a href="https://github.com/chaoslawful/lua-nginx-module" rel="external nofollow noreferrer">nginx_lua_module</a>可以将Lua语言嵌入到Nginx配置中，从而利用Lua极大增强了Nginx本身的编程能力，甚至可以不用配合其它脚本语言（如PHP或Python等），只靠Nginx本身就可以实现复杂业务的处理。而春来所开发的<a href="https://github.com/agentzh/ngx_openresty" rel="external nofollow noreferrer">ngx_openresty</a>更是通过集成<a href="http://luajit.org/" rel="external nofollow noreferrer">LuaJIT</a>等组件，将Nginx本身变成了一个完全的应用开发平台。目前淘宝数据平台与产品部量子统计的产品都是基于ngx_openresty所开发。对ngxin_lua_module或ngx_openresty感兴趣的朋友可以参考我在关键词上给出的链接，后续我也可能会写一些与其有关的文章。</p>
<p>本文将会重点关注Nginx模块开发入门及基础。目前Nginx的学习资料非常少，而扩展模块开发相关的资料几乎只有《<a href="http://www.evanmiller.org/nginx-modules-guide.html" rel="external nofollow noreferrer">Emiller‘s Guide To Nginx Module Development</a>》一文，此文十分经典，但是由于Nginx版本的演进，其中少许内容可能有点过时。本文是笔者在研读这篇文章和Nginx源代码的基础上，对自己学习Nginx模块开发的一个总结。本文将通过一个完整的模块开发实例讲解Nginx模块开发的入门内容。</p>
<p>本文将基于Nginx最新的<a href="http://nginx.org/download/nginx-1.0.0.tar.gz" rel="external nofollow noreferrer">1.0.0</a>版本，操作系统环境为Linux（Ubuntu10.10）。</p>
<p><a href="http://kb.cnblogs.com/page/98352/#section0" rel="external nofollow noreferrer">前言</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section1" rel="external nofollow noreferrer">Nginx提要</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section1-1" rel="external nofollow noreferrer">Nginx在Linux下的安装与运行</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section1-2" rel="external nofollow noreferrer">Nginx配置文件基本结构</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section1-3" rel="external nofollow noreferrer">Nginx模块工作原理概述</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2" rel="external nofollow noreferrer">Nginx模块开发实战</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2-1" rel="external nofollow noreferrer">定义模块配置结构</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2-2" rel="external nofollow noreferrer">定义指令</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2-3" rel="external nofollow noreferrer">创建合并配置信息</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2-4" rel="external nofollow noreferrer">编写Handler</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section2-5" rel="external nofollow noreferrer">组合Nginx Module</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section3" rel="external nofollow noreferrer">Nginx模块的安装</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section4" rel="external nofollow noreferrer">Nginx更深入的学习</a></p>
<p><a href="http://kb.cnblogs.com/page/98352/#section5" rel="external nofollow noreferrer">Nginx参考文献</a></p>
<h1>Nginx提要</h1>
<p>开发Nginx扩展当然首要前提是对Nginx有一定的了解，然而本文并不打算详细阐述Nginx的方方面面，诸如Nginx的安装和各种详细配置等内容都可以在Nginx官网的Document中找到，本文在这里只会概括性描述一些后面可能会用到的原理和概念。</p>
<h2>Nginx在Linux下的安装与运行</h2>
<p>使用Nginx的第一步是下载Nginx源码包，例如1.0.0的下载地址为<a href="http://nginx.org/download/nginx-1.0.0.tar.gz" rel="external nofollow noreferrer">http://nginx.org/download/nginx-1.0.0.tar.gz</a>。下载完后用tar命令解压缩，进入目录后安装过程与Linux下通常步骤无异，例如我想讲Nginx安装到/usr/local/nginx下，则执行如下命令：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>.</code><code>/configure</code>&nbsp;<code>--perfix=</code><code>/usr/local/nginx</code></p>
<p><code>make</code></p>
<p><code>make</code>&nbsp;<code>install</code></p>
</td>
</tr>
</tbody>
</table>
<p>安装完成后可以直接使用下面命令启动Nginx：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>/usr/local/nginx/sbin/nginx</code></p>
</td>
</tr>
</tbody>
</table>
<p>Nginx默认以Deamon进程启动，输入下列命令：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>curl -i http:</code><code>//localhost/</code></p>
</td>
</tr>
</tbody>
</table>
<p>就可以检测Nginx是否已经成功运行。或者也可以在浏览器中输入<a href="http://localhost/" rel="external nofollow noreferrer">http://localhost/</a>，应该可以看到Nginx的欢迎页面了。启动后如果想停止Nginx可以使用：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>/usr/local/nginx/sbin/nginx</code>&nbsp;<code>-s stop</code></p>
</td>
</tr>
</tbody>
</table>
<h2>Nginx配置文件基本结构</h2>
<p>配置文件可以看做是Nginx的灵魂，Nginx服务在启动时会读入配置文件，而后续几乎一切动作行为都是按照配置文件中的指令进行的，因此如果将Nginx本身看做一个计算机，那么Nginx的配置文件可以看成是全部的程序指令。</p>
<p>下面是一个Nginx配置文件的实例：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30
</td>
<td>
<p><code>#user&nbsp; nobody;</code></p>
<p><code>worker_processes&nbsp; 8;</code></p>
<p><code>error_log&nbsp; logs</code><code>/error</code><code>.log;</code></p>
<p><code>pid&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; logs</code><code>/nginx</code><code>.pid;</code></p>
<p><code>events {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>worker_connections&nbsp; 1024;</code></p>
<p><code>}</code></p>
<p><code>http {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>include&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; mime.types;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>default_type&nbsp; application</code><code>/octet-stream</code><code>;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>sendfile&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; on;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>#tcp_nopush&nbsp;&nbsp;&nbsp;&nbsp; on;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>keepalive_timeout&nbsp; 65;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>#gzip&nbsp; on;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>server {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>listen&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 80;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>server_name&nbsp; localhost;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>location / {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>root&nbsp;&nbsp; </code><code>/home/yefeng/www</code><code>;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>index&nbsp; index.html index.htm;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>#error_page&nbsp; 404&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /404.html;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># redirect server error pages to the static page /50x.html</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>#</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>error_page&nbsp;&nbsp; 500 502 503 504&nbsp; </code><code>/50x</code><code>.html;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>location = </code><code>/50x</code><code>.html {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>root&nbsp;&nbsp; html;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>Nginx配置文件是纯文本文件，你可以用任何文本编辑器如vim或emacs打开它，通常它会在nginx安装目录的conf下，如我的nginx安装在/usr/local/nginx，主配置文件默认放在/usr/local/nginx/conf/nginx.conf。</p>
<p>其中&ldquo;#&rdquo;表示此行是注释，由于笔者为了学习扩展开发安装了一个纯净的Nginx，因此配置文件没有经过太多改动。</p>
<p>Nginx的配置文件是以block的形式组织的，一个block通常使用大括号&ldquo;{}&rdquo;表示。block分为几个层级，整个配置文件为main层级，这是最大的层级；在main层级下可以有event、http等层级，而http中又会有server block，server block中可以包含location block。</p>
<p>每个层级可以有自己的指令（Directive），例如worker_processes是一个main层级指令，它指定Nginx服务的Worker进程数量。有的指令只能在一个层级中配置，如worker_processes只能存在于main中，而有的指令可以存在于多个层级，在这种情况下，子block会继承父block的配置，同时如果子block配置了与父block不同的指令，则会覆盖掉父block的配置。指令的格式是&ldquo;指令名 参数1&nbsp; 参数2 &hellip; 参数N;&rdquo;，注意参数间可用任意数量空格分隔，最后要加分号。</p>
<p>在开发Nginx HTTP扩展模块过程中，需要特别注意的是main、server和location三个层级，因为扩展模块通常允许指定新的配置指令在这三个层级中。</p>
<p>最后要提到的是配置文件是可以包含的，如上面配置文件中&ldquo;include mime.types&rdquo;就包含了mine.types这个配置文件，此文件指定了各种HTTP Content-type。</p>
<p>一般来说，一个server block表示一个Host，而里面的一个location则代表一个路由映射规则，这两个block可以说是HTTP配置的核心。</p>
<p>下图是Nginx配置文件通常结构图示。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL2xlb28yc2svMjAxMTA0LzIwMTEwNDE3MjIxMjMyNDY1Ni5wbmc=.jpg" /></p>
<p>关于Nginx配置的更多内容请参看Nginx官方文档。</p>
<h2>Nginx模块工作原理概述</h2>
<p>（Nginx本身支持多种模块，如HTTP模块、EVENT模块和MAIL模块，本文只讨论HTTP模块）</p>
<p>Nginx本身做的工作实际很少，当它接到一个HTTP请求时，它仅仅是通过查找配置文件将此次请求映射到一个location block，而此location中所配置的各个指令则会启动不同的模块去完成工作，因此模块可以看做Nginx真正的劳动工作者。通常一个location中的指令会涉及一个handler模块和多个filter模块（当然，多个location可以复用同一个模块）。handler模块负责处理请求，完成响应内容的生成，而filter模块对响应内容进行处理。因此Nginx模块开发分为handler开发和filter开发（本文不考虑load-balancer模块）。下图展示了一次常规请求和响应的过程。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL2xlb28yc2svMjAxMTA0LzIwMTEwNDE3MTcyMDUwNzM4Ny5wbmc=.jpg" /></p>
<h1>Nginx模块开发实战</h1>
<p>下面本文展示一个简单的Nginx模块开发全过程，我们开发一个叫echo的handler模块，这个模块功能非常简单，它接收&ldquo;echo&rdquo;指令，指令可指定一个字符串参数，模块会输出这个字符串作为HTTP响应。例如，做如下配置：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>location </code><code>/echo</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>echo</code>&nbsp;<code>"hello nginx"</code><code>;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>则访问<a href="http://hostname/echo" rel="external nofollow noreferrer">http://hostname/echo</a>时会输出hello nginx。</p>
<p>直观来看，要实现这个功能需要三步：1、读入配置文件中echo指令及其参数；2、进行HTTP包装（添加HTTP头等工作）；3、将结果返回给客户端。下面本文将分部介绍整个模块的开发过程。</p>
<h2>定义模块配置结构</h2>
<p>首先我们需要一个结构用于存储从配置文件中读进来的相关指令参数，即模块配置信息结构。根据Nginx模块开发规则，这个结构的命名规则为ngx_http_[module-name]_[main|srv|loc]_conf_t。其中main、srv和loc分别用于表示同一模块在三层block中的配置信息。这里我们的echo模块只需要运行在loc层级下，需要存储一个字符串参数，因此我们可以定义如下的模块配置：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>typedef</code>&nbsp;<code>struct</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp; ed;</code></p>
<p><code>} ngx_http_echo_loc_conf_t;</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中字段ed用于存储echo指令指定的需要输出的字符串。注意这里ed的类型，在Nginx模块开发中使用ngx_str_t类型表示字符串，这个类型定义在core/ngx_string中：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>typedef</code>&nbsp;<code>struct</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>size_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>len;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>u_char&nbsp;&nbsp;&nbsp;&nbsp; *data;</code></p>
<p><code>} ngx_str_t;</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中两个字段分别表示字符串的长度和数据起始地址。注意在Nginx源代码中对数据类型进行了别称定义，如ngx_int_t为intptr_t的别称，为了保持一致，在开发Nginx模块时也应该使用这些Nginx源码定义的类型而不要使用C原生类型。除了ngx_str_t外，其它三个常用的nginx type分别为：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>typedef</code>&nbsp;<code>intptr_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>ngx_int_t;</code></p>
<p><code>typedef</code>&nbsp;<code>uintptr_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>ngx_uint_t;</code></p>
<p><code>typedef</code>&nbsp;<code>intptr_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>ngx_flag_t;</code></p>
</td>
</tr>
</tbody>
</table>
<p>具体定义请参看core/ngx_config.h。关于intptr_t和uintptr_t请参考C99中的<a href="http://linux.die.net/include/stdint.h" rel="external nofollow noreferrer">stdint.h</a>或<a href="http://linux.die.net/man/3/intptr_t" rel="external nofollow noreferrer">http://linux.die.net/man/3/intptr_t</a>。</p>
<h2>定义指令</h2>
<p>一个Nginx模块往往接收一至多个指令，echo模块接收一个指令&ldquo;echo&rdquo;。Nginx模块使用一个ngx_command_t数组表示模块所能接收的所有模块，其中每一个元素表示一个条指令。ngx_command_t是ngx_command_s的一个别称（Nginx习惯于使用&ldquo;_s&rdquo;后缀命名结构体，然后typedef一个同名&ldquo;_t&rdquo;后缀名称作为此结构体的类型名），ngx_command_s定义在core/ngx_config_file.h中：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8
</td>
<td>
<p><code>struct</code>&nbsp;<code>ngx_command_s {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; name;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; type;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>char</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>*(*set)(ngx_conf_t *cf, ngx_command_t *cmd, </code><code>void</code>&nbsp;<code>*conf);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; conf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; offset;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>*post;</code></p>
<p><code>};</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中name是词条指令的名称，type使用掩码标志位方式配置指令参数，相关可用type定义在core/ngx_config_file.h中：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27
</td>
<td>
<p><code>#define NGX_CONF_NOARGS&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000001</code></p>
<p><code>#define NGX_CONF_TAKE1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000002</code></p>
<p><code>#define NGX_CONF_TAKE2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000004</code></p>
<p><code>#define NGX_CONF_TAKE3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000008</code></p>
<p><code>#define NGX_CONF_TAKE4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000010</code></p>
<p><code>#define NGX_CONF_TAKE5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000020</code></p>
<p><code>#define NGX_CONF_TAKE6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000040</code></p>
<p><code>#define NGX_CONF_TAKE7&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000080</code></p>

<p><code>#define NGX_CONF_MAX_ARGS&nbsp;&nbsp;&nbsp; 8</code></p>

<p><code>#define NGX_CONF_TAKE12&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (NGX_CONF_TAKE1|NGX_CONF_TAKE2)</code></p>
<p><code>#define NGX_CONF_TAKE13&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (NGX_CONF_TAKE1|NGX_CONF_TAKE3)</code></p>

<p><code>#define NGX_CONF_TAKE23&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (NGX_CONF_TAKE2|NGX_CONF_TAKE3)</code></p>

<p><code>#define NGX_CONF_TAKE123&nbsp;&nbsp;&nbsp;&nbsp; (NGX_CONF_TAKE1|NGX_CONF_TAKE2|NGX_CONF_TAKE3)</code></p>
<p><code>#define NGX_CONF_TAKE1234&nbsp;&nbsp;&nbsp; (NGX_CONF_TAKE1|NGX_CONF_TAKE2|NGX_CONF_TAKE3&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>|NGX_CONF_TAKE4)</code></p>

<p><code>#define NGX_CONF_ARGS_NUMBER 0x000000ff</code></p>
<p><code>#define NGX_CONF_BLOCK&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000100</code></p>
<p><code>#define NGX_CONF_FLAG&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000200</code></p>
<p><code>#define NGX_CONF_ANY&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000400</code></p>
<p><code>#define NGX_CONF_1MORE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00000800</code></p>
<p><code>#define NGX_CONF_2MORE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00001000</code></p>
<p><code>#define NGX_CONF_MULTI&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0x00002000</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中NGX_CONF_NOARGS表示此指令不接受参数，NGX_CON F_TAKE1-7表示精确接收1-7个，NGX_CONF_TAKE12表示接受1或2个参数，NGX_CONF_1MORE表示至少一个参数，NGX_CONF_FLAG表示接受&ldquo;on|off&rdquo;&hellip;&hellip;</p>
<p>set是一个函数指针，用于指定一个参数转化函数，这个函数一般是将配置文件中相关指令的参数转化成需要的格式并存入配置结构体。Nginx预定义了一些转换函数，可以方便我们调用，这些函数定义在core/ngx_conf_file.h中，一般以&ldquo;_slot&rdquo;结尾，例如ngx_conf_set_flag_slot将&ldquo;on或off&rdquo;转换为&ldquo;1或0&rdquo;，再如ngx_conf_set_str_slot将裸字符串转化为ngx_str_t。</p>
<p>conf用于指定Nginx相应配置文件内存其实地址，一般可以通过内置常量指定，如NGX_HTTP_LOC_CONF_OFFSET，offset指定此条指令的参数的偏移量。</p>
<p>下面是echo模块的指令定义：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10
</td>
<td>
<p><code>static</code>&nbsp;<code>ngx_command_t&nbsp; ngx_http_echo_commands[] = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{ ngx_string(</code><code>"echo"</code><code>),</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_LOC_CONF_OFFSET,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>offsetof(ngx_http_echo_loc_conf_t, ed),</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL },</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_null_command</code></p>
<p><code>};</code></p>
</td>
</tr>
</tbody>
</table>
<p>指令数组的命名规则为ngx_http_[module-name]_commands，注意数组最后一个元素要是ngx_null_command结束。</p>
<p>参数转化函数的代码为：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10
</td>
<td>
<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, </code><code>void</code>&nbsp;<code>*conf)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_core_loc_conf_t&nbsp; *clcf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>clcf = ngx_http_conf_get_module_loc_conf(cf, ngx_http_core_module);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>clcf-&gt;handler = ngx_http_echo_handler;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_conf_set_str_slot(cf,cmd,conf);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_OK;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>这个函数除了调用ngx_conf_set_str_slot转化echo指令的参数外，还将修改了核心模块配置（也就是这个location的配置），将其handler替换为我们编写的handler：ngx_http_echo_handler。这样就屏蔽了此location的默认handler，使用ngx_http_echo_handler产生HTTP响应。</p>
<h2>创建合并配置信息</h2>
<p>下一步是定义模块Context。</p>
<p>这里首先需要定义一个ngx_http_module_t类型的结构体变量，命名规则为ngx_http_[module-name]_module_ctx，这个结构主要用于定义各个Hook函数。下面是echo模块的context结构：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13
</td>
<td>
<p><code>static</code>&nbsp;<code>ngx_http_module_t&nbsp; ngx_http_echo_module_ctx = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* preconfiguration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* postconfiguration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create main configuration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init main configuration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create server configuration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* merge server configuration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_create_loc_conf,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create location configration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_merge_loc_conf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* merge location configration */</code></p>
<p><code>};</code></p>
</td>
</tr>
</tbody>
</table>
<p>可以看到一共有8个Hook注入点，分别会在不同时刻被Nginx调用，由于我们的模块仅仅用于location域，这里将不需要的注入点设为NULL即可。其中create_loc_conf用于初始化一个配置结构体，如为配置结构体分配内存等工作；merge_loc_conf用于将其父block的配置信息合并到此结构体中，也就是实现配置的继承。这两个函数会被Nginx自动调用。注意这里的命名规则：ngx_http_[module-name]_[create|merge]_[main|srv|loc]_conf。</p>
<p>下面是echo模块这个两个函数的代码：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25
</td>
<td>
<p><code>static</code>&nbsp;<code>void</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo_create_loc_conf(ngx_conf_t *cf)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t&nbsp; *conf;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf = ngx_pcalloc(cf-&gt;pool, </code><code>sizeof</code><code>(ngx_http_echo_loc_conf_t));</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(conf == NULL) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_ERROR;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf-&gt;ed.len = 0;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf-&gt;ed.data = NULL;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>conf;</code></p>
<p><code>}</code></p>

<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, </code><code>void</code>&nbsp;<code>*parent, </code><code>void</code>&nbsp;<code>*child)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *prev = parent;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *conf = child;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_conf_merge_str_value(conf-&gt;ed, prev-&gt;ed, </code><code>""</code><code>);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_OK;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中ngx_pcalloc用于在Nginx内存池中分配一块空间，是pcalloc的一个包装。使用ngx_pcalloc分配的内存空间不必手工free，Nginx会自行管理，在适当是否释放。</p>
<p>create_loc_conf新建一个ngx_http_echo_loc_conf_t，分配内存，并初始化其中的数据，然后返回这个结构的指针；merge_loc_conf将父block域的配置信息合并到create_loc_conf新建的配置结构体中。</p>
<p>其中ngx_conf_merge_str_value不是一个函数，而是一个宏，其定义在core/ngx_conf_file.h中：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10
</td>
<td>
<p><code>#define ngx_conf_merge_str_value(conf, prev, default)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(conf.data == NULL) {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(prev.data) {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf.len = prev.len;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf.data = prev.data;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>} </code><code>else</code>&nbsp;<code>{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf.len = </code><code>sizeof</code><code>(</code><code>default</code><code>) - 1;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf.data = (u_char *) </code><code>default</code><code>;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>同时可以看到，core/ngx_conf_file.h还定义了很多merge value的宏用于merge各种数据。它们的行为比较相似：使用prev填充conf，如果prev的数据为空则使用default填充。</p>
<h2>编写Handler</h2>
<p>下面的工作是编写handler。handler可以说是模块中真正干活的代码，它主要有以下四项职责：</p>
<p>读入模块配置。</p>
<p>处理功能业务。</p>
<p>产生HTTP header。</p>
<p>产生HTTP body。</p>
<p>下面先贴出echo模块的代码，然后通过分析代码的方式介绍如何实现这四步。这一块的代码比较复杂：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46</p>
<p>47</p>
<p>48</p>
<p>49</p>
<p>50
</td>
<td>
<p><code>static</code>&nbsp;<code>ngx_int_t</code></p>
<p><code>ngx_http_echo_handler(ngx_http_request_t *r)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_int_t rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_buf_t *b;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_chain_t out;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *elcf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>elcf = ngx_http_get_module_loc_conf(r, ngx_http_echo_module);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(!(r-&gt;method &amp; (NGX_HTTP_HEAD|NGX_HTTP_GET|NGX_HTTP_POST)))</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_HTTP_NOT_ALLOWED;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_type.len = </code><code>sizeof</code><code>(</code><code>"text/html"</code><code>) - 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_type.data = (u_char *) </code><code>"text/html"</code><code>;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.status = NGX_HTTP_OK;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_length_n = elcf-&gt;ed.len;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(r-&gt;method == NGX_HTTP_HEAD)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>rc = ngx_http_send_header(r);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(rc != NGX_OK)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b = ngx_pcalloc(r-&gt;pool, </code><code>sizeof</code><code>(ngx_buf_t));</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(b == NULL)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_log_error(NGX_LOG_ERR, r-&gt;connection-&gt;</code><code>log</code><code>, 0, </code><code>"Failed to allocate response buffer."</code><code>);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_HTTP_INTERNAL_SERVER_ERROR;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>out.buf = b;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>out.next = NULL;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;pos = elcf-&gt;ed.data;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;last = elcf-&gt;ed.data + (elcf-&gt;ed.len);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;memory = 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;last_buf = 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>rc = ngx_http_send_header(r);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(rc != NGX_OK)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>ngx_http_output_filter(r, &amp;out);</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>handler会接收一个ngx_http_request_t指针类型的参数，这个参数指向一个ngx_http_request_t结构体，此结构体存储了这次HTTP请求的一些信息，这个结构定义在http/ngx_http_request.h中：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46</p>
<p>47</p>
<p>48</p>
<p>49</p>
<p>50</p>
<p>51</p>
<p>52</p>
<p>53</p>
<p>54</p>
<p>55</p>
<p>56</p>
<p>57</p>
<p>58</p>
<p>59</p>
<p>60</p>
<p>61</p>
<p>62
</td>
<td>
<p><code>struct</code>&nbsp;<code>ngx_http_request_s {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>uint32_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; signature;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* "HTTP" */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_connection_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *connection;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>**ctx;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>**main_conf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>**srv_conf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>**loc_conf;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_event_handler_pt&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; read_event_handler;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_event_handler_pt&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; write_event_handler;</code></p>

<p><code>#if (NGX_HTTP_CACHE)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_cache_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *cache;</code></p>
<p><code>#endif</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_upstream_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *upstream;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_array_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *upstream_states;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/* of ngx_http_upstream_state_t */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_pool_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *pool;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_buf_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *header_in;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_headers_in_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; headers_in;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_headers_out_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; headers_out;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_request_body_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *request_body;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>time_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>lingering_time;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>time_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>start_sec;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_msec_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; start_msec;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; method;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; http_version;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; request_line;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; uri;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; args;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; exten;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; unparsed_uri;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; method_name;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; http_protocol;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_chain_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *out;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_request_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *main;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_request_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *parent;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_postponed_request_t&nbsp;&nbsp;&nbsp;&nbsp; *postponed;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_post_subrequest_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *post_subrequest;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_posted_request_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *posted_requests;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_virtual_names_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *virtual_names;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_int_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phase_handler;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_handler_pt&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; content_handler;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; access_code;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_variable_value_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *variables;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/* ... */</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>由于ngx_http_request_s定义比较长，这里我只截取了一部分。可以看到里面有诸如uri，args和request_body等HTTP常用信息。这里需要特别注意的几个字段是headers_in、headers_out和chain，它们分别表示request header、response header和输出数据缓冲区链表（缓冲区链表是Nginx I/O中的重要内容，后面会单独介绍）。</p>
<p>第一步是获取模块配置信息，这一块只要简单使用ngx_http_get_module_loc_conf就可以了。</p>
<p>第二步是功能逻辑，因为echo模块非常简单，只是简单输出一个字符串，所以这里没有功能逻辑代码。</p>
<p>第三步是设置response header。Header内容可以通过填充headers_out实现，我们这里只设置了Content-type和Content-length等基本内容，ngx_http_headers_out_t定义了所有可以设置的HTTP Response Header信息：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33
</td>
<td>
<p><code>typedef</code>&nbsp;<code>struct</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_list_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; headers;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; status;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; status_line;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *server;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *date;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *content_length;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *content_encoding;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *location;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *refresh;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *last_modified;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *content_range;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *accept_ranges;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *www_authenticate;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *expires;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_table_elt_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *etag;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *override_charset;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>size_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>content_type_len;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; content_type;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; charset;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>u_char&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; *content_type_lowcase;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_uint_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; content_type_hash;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_array_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; cache_control;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>off_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; content_length_n;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>time_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>date_time;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>time_t</code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>last_modified_time;</code></p>
<p><code>} ngx_http_headers_out_t;</code></p>
</td>
</tr>
</tbody>
</table>
<p>这里并不包含所有HTTP头信息，如果需要可以使用agentzh（春来）开发的Nginx模块<a href="http://wiki.nginx.org/HttpHeadersMoreModule" rel="external nofollow noreferrer">HttpHeadersMore</a>在指令中指定更多的Header头信息。</p>
<p>设置好头信息后使用ngx_http_send_header就可以将头信息输出，ngx_http_send_header接受一个ngx_http_request_t类型的参数。</p>
<p>第四步也是最重要的一步是输出Response body。这里首先要了解Nginx的I/O机制，Nginx允许handler一次产生一组输出，可以产生多次，Nginx将输出组织成一个单链表结构，链表中的每个节点是一个chain_t，定义在core/ngx_buf.h：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>struct</code>&nbsp;<code>ngx_chain_s {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_buf_t&nbsp;&nbsp;&nbsp; *buf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_chain_t&nbsp; *next;</code></p>
<p><code>};</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中ngx_chain_t是ngx_chain_s的别名，buf为某个数据缓冲区的指针，next指向下一个链表节点，可以看到这是一个非常简单的链表。ngx_buf_t的定义比较长而且很复杂，这里就不贴出来了，请自行参考core/ngx_buf.h。ngx_but_t中比较重要的是pos和last，分别表示要缓冲区数据在内存中的起始地址和结尾地址，这里我们将配置中字符串传进去，last_buf是一个位域，设为1表示此缓冲区是链表中最后一个元素，为0表示后面还有元素。因为我们只有一组数据，所以缓冲区链表中只有一个节点，如果需要输入多组数据可将各组数据放入不同缓冲区后插入到链表。下图展示了Nginx缓冲链表的结构：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL2xlb28yc2svMjAxMTA0LzIwMTEwNDE5MTE1NTAyNTc5MS5wbmc=.jpg" /></p>
<p>缓冲数据准备好后，用ngx_http_output_filter就可以输出了（会送到filter进行各种过滤处理）。ngx_http_output_filter的第一个参数为ngx_http_request_t结构，第二个为输出链表的起始地址&amp;out。ngx_http_out_put_filter会遍历链表，输出所有数据。</p>
<p>以上就是handler的所有工作，请对照描述理解上面贴出的handler代码。</p>
<h2>组合Nginx Module</h2>
<p>上面完成了Nginx模块各种组件的开发下面就是将这些组合起来了。一个Nginx模块被定义为一个ngx_module_t结构，这个结构的字段很多，不过开头和结尾若干字段一般可以通过Nginx内置的宏去填充，下面是我们echo模块的模块主体定义：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14
</td>
<td>
<p><code>ngx_module_t&nbsp; ngx_http_echo_module = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_MODULE_V1,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>&amp;ngx_http_echo_module_ctx,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module context */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_commands,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module directives */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_MODULE,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module type */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init master */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init module */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init process */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init thread */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit thread */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit process */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit master */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_MODULE_V1_PADDING</code></p>
<p><code>};</code></p>
</td>
</tr>
</tbody>
</table>
<p>开头和结尾分别用NGX_MODULE_V1和NGX_MODULE_V1_PADDING 填充了若干字段，就不去深究了。这里主要需要填入的信息从上到下以依次为context、指令数组、模块类型以及若干特定事件的回调处理函数（不需要可以置为NULL），其中内容还是比较好理解的，注意我们的echo是一个HTTP模块，所以这里类型是NGX_HTTP_MODULE，其它可用类型还有NGX_EVENT_MODULE（事件处理模块）和NGX_MAIL_MODULE（邮件模块）。</p>
<p>这样，整个echo模块就写好了，下面给出echo模块的完整代码：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46</p>
<p>47</p>
<p>48</p>
<p>49</p>
<p>50</p>
<p>51</p>
<p>52</p>
<p>53</p>
<p>54</p>
<p>55</p>
<p>56</p>
<p>57</p>
<p>58</p>
<p>59</p>
<p>60</p>
<p>61</p>
<p>62</p>
<p>63</p>
<p>64</p>
<p>65</p>
<p>66</p>
<p>67</p>
<p>68</p>
<p>69</p>
<p>70</p>
<p>71</p>
<p>72</p>
<p>73</p>
<p>74</p>
<p>75</p>
<p>76</p>
<p>77</p>
<p>78</p>
<p>79</p>
<p>80</p>
<p>81</p>
<p>82</p>
<p>83</p>
<p>84</p>
<p>85</p>
<p>86</p>
<p>87</p>
<p>88</p>
<p>89</p>
<p>90</p>
<p>91</p>
<p>92</p>
<p>93</p>
<p>94</p>
<p>95</p>
<p>96</p>
<p>97</p>
<p>98</p>
<p>99</p>
<p>100</p>
<p>101</p>
<p>102</p>
<p>103</p>
<p>104</p>
<p>105</p>
<p>106</p>
<p>107</p>
<p>108</p>
<p>109</p>
<p>110</p>
<p>111</p>
<p>112</p>
<p>113</p>
<p>114</p>
<p>115</p>
<p>116</p>
<p>117</p>
<p>118</p>
<p>119</p>
<p>120</p>
<p>121</p>
<p>122</p>
<p>123</p>
<p>124</p>
<p>125</p>
<p>126</p>
<p>127</p>
<p>128</p>
<p>129</p>
<p>130</p>
<p>131</p>
<p>132</p>
<p>133</p>
<p>134</p>
<p>135</p>
<p>136</p>
<p>137</p>
<p>138</p>
<p>139</p>
<p>140</p>
<p>141</p>
<p>142</p>
<p>143</p>
<p>144</p>
<p>145</p>
<p>146</p>
<p>147</p>
<p>148
</td>
<td>
<p><code>/*</code></p>
<p><code>&nbsp;</code><code>* Copyright (C) Eric Zhang</code></p>
<p><code>&nbsp;</code><code>*/</code></p>

<p><code>#include &lt;ngx_config.h&gt;</code></p>
<p><code>#include &lt;ngx_core.h&gt;</code></p>
<p><code>#include &lt;ngx_http.h&gt;</code></p>

<p><code>/* Module config */</code></p>
<p><code>typedef</code>&nbsp;<code>struct</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_str_t&nbsp; ed;</code></p>
<p><code>} ngx_http_echo_loc_conf_t;</code></p>

<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, </code><code>void</code>&nbsp;<code>*conf);</code></p>
<p><code>static</code>&nbsp;<code>void</code>&nbsp;<code>*ngx_http_echo_create_loc_conf(ngx_conf_t *cf);</code></p>
<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, </code><code>void</code>&nbsp;<code>*parent, </code><code>void</code>&nbsp;<code>*child);</code></p>

<p><code>/* Directives */</code></p>
<p><code>static</code>&nbsp;<code>ngx_command_t&nbsp; ngx_http_echo_commands[] = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{ ngx_string(</code><code>"echo"</code><code>),</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_LOC_CONF_OFFSET,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>offsetof(ngx_http_echo_loc_conf_t, ed),</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL },</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_null_command</code></p>
<p><code>};</code></p>

<p><code>/* Http context of the module */</code></p>
<p><code>static</code>&nbsp;<code>ngx_http_module_t&nbsp; ngx_http_echo_module_ctx = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* preconfiguration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* postconfiguration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create main configuration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init main configuration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create server configuration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* merge server configuration */</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_create_loc_conf,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* create location configration */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_merge_loc_conf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* merge location configration */</code></p>
<p><code>};</code></p>

<p><code>/* Module */</code></p>
<p><code>ngx_module_t&nbsp; ngx_http_echo_module = {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_MODULE_V1,</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>&amp;ngx_http_echo_module_ctx,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module context */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_commands,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module directives */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_HTTP_MODULE,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* module type */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init master */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init module */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init process */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* init thread */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit thread */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit process */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code><code>/* exit master */</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>NGX_MODULE_V1_PADDING</code></p>
<p><code>};</code></p>

<p><code>/* Handler function */</code></p>
<p><code>static</code>&nbsp;<code>ngx_int_t</code></p>
<p><code>ngx_http_echo_handler(ngx_http_request_t *r)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_int_t rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_buf_t *b;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_chain_t out;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *elcf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>elcf = ngx_http_get_module_loc_conf(r, ngx_http_echo_module);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(!(r-&gt;method &amp; (NGX_HTTP_HEAD|NGX_HTTP_GET|NGX_HTTP_POST)))</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_HTTP_NOT_ALLOWED;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_type.len = </code><code>sizeof</code><code>(</code><code>"text/html"</code><code>) - 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_type.data = (u_char *) </code><code>"text/html"</code><code>;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.status = NGX_HTTP_OK;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r-&gt;headers_out.content_length_n = elcf-&gt;ed.len;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(r-&gt;method == NGX_HTTP_HEAD)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>rc = ngx_http_send_header(r);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(rc != NGX_OK)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b = ngx_pcalloc(r-&gt;pool, </code><code>sizeof</code><code>(ngx_buf_t));</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(b == NULL)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_log_error(NGX_LOG_ERR, r-&gt;connection-&gt;</code><code>log</code><code>, 0, </code><code>"Failed to allocate response buffer."</code><code>);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_HTTP_INTERNAL_SERVER_ERROR;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>out.buf = b;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>out.next = NULL;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;pos = elcf-&gt;ed.data;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;last = elcf-&gt;ed.data + (elcf-&gt;ed.len);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;memory = 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b-&gt;last_buf = 1;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>rc = ngx_http_send_header(r);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code><code>(rc != NGX_OK)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>rc;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>ngx_http_output_filter(r, &amp;out);</code></p>
<p><code>}</code></p>

<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, </code><code>void</code>&nbsp;<code>*conf)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_core_loc_conf_t&nbsp; *clcf;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>clcf = ngx_http_conf_get_module_loc_conf(cf, ngx_http_core_module);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>clcf-&gt;handler = ngx_http_echo_handler;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_conf_set_str_slot(cf,cmd,conf);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_OK;</code></p>
<p><code>}</code></p>

<p><code>static</code>&nbsp;<code>void</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo_create_loc_conf(ngx_conf_t *cf)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t&nbsp; *conf;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf = ngx_pcalloc(cf-&gt;pool, </code><code>sizeof</code><code>(ngx_http_echo_loc_conf_t));</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(conf == NULL) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_ERROR;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf-&gt;ed.len = 0;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>conf-&gt;ed.data = NULL;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>conf;</code></p>
<p><code>}</code></p>

<p><code>static</code>&nbsp;<code>char</code>&nbsp;<code>*</code></p>
<p><code>ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, </code><code>void</code>&nbsp;<code>*parent, </code><code>void</code>&nbsp;<code>*child)</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *prev = parent;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_http_echo_loc_conf_t *conf = child;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ngx_conf_merge_str_value(conf-&gt;ed, prev-&gt;ed, </code><code>""</code><code>);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>NGX_CONF_OK;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<h1>Nginx模块的安装</h1>
<p>Nginx不支持动态链接模块，所以安装模块需要将模块代码与Nginx源代码进行重新编译。安装模块的步骤如下：</p>
<p>1、编写模块config文件，这个文件需要放在和模块源代码文件放在同一目录下。文件内容如下：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>ngx_addon_name=模块完整名称</code></p>
<p><code>HTTP_MODULES=</code><code>"$HTTP_MODULES 模块完整名称"</code></p>
<p><code>NGX_ADDON_SRCS=</code><code>"$NGX_ADDON_SRCS $ngx_addon_dir/源代码文件名"</code></p>
</td>
</tr>
</tbody>
</table>
<p>2、进入Nginx源代码，使用下面命令编译安装</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>./configure --prefix=安装目录 --add-module=模块源代码文件目录</code></p>
<p><code>make</code></p>
<p><code>make install</code></p>
</td>
</tr>
</tbody>
</table>
<p>这样就完成安装了，例如，我的源代码文件放在/home/yefeng/ngxdev/ngx_http_echo下，我的config文件为：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>ngx_addon_name=ngx_http_echo_module</code></p>
<p><code>HTTP_MODULES=</code><code>"$HTTP_MODULES ngx_http_echo_module"</code></p>
<p><code>NGX_ADDON_SRCS=</code><code>"$NGX_ADDON_SRCS $ngx_addon_dir/ngx_http_echo_module.c"</code></p>
</td>
</tr>
</tbody>
</table>
<p>编译安装命令为：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>./configure --prefix=/usr/local/nginx --add-module=/home/yefeng/ngxdev/ngx_http_echo</code></p>
<p><code>make</code></p>
<p><code>sudo make install</code></p>
</td>
</tr>
</tbody>
</table>
<p>这样echo模块就被安装在我的Nginx上了，下面测试一下，修改配置文件，增加以下一项配置：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>location </code><code>/echo</code>&nbsp;<code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>echo</code>&nbsp;<code>"This is my first nginx module!!!"</code><code>;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>然后用curl测试一下：</p>
<p><a href="http://kb.cnblogs.com/page/98352/" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>curl -i http:</code><code>//localhost/echo</code></p>
</td>
</tr>
</tbody>
</table>
<p>结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL2xlb28yc2svMjAxMTA0LzIwMTEwNDE5MTMwMDQxNTgzNi5wbmc=.jpg" /></p>
<p>可以看到模块已经正常工作了，也可以在浏览器中打开网址，就可以看到结果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL2xlb28yc2svMjAxMTA0LzIwMTEwNDE5MTMwMDQzNzgzMC5wbmc=.jpg" /></p>
<h1>更深入的学习</h1>
<p>本文只是简要介绍了Nginx模块的开发过程，由于篇幅的原因，不能面面俱到。因为目前Nginx的学习资料很少，如果读者希望更深入学习Nginx的原理及模块开发，那么阅读源代码是最好的办法。在Nginx源代码的core/下放有Nginx的核心代码，对理解Nginx的内部工作机制非常有帮助，http/目录下有Nginx HTTP相关的实现，http/module下放有大量内置http模块，可供读者学习模块的开发，另外在<a href="http://wiki.nginx.org/3rdPartyModules" rel="external nofollow noreferrer">http://wiki.nginx.org/3rdPartyModules</a>上有大量优秀的第三方模块，也是非常好的学习资料。</p>
<p>如有意见建议或疑问欢迎发送邮件至[email&#160;protected]。希望本文对您有所帮助！！！</p>
<h1>参考文献</h1>
<p>[1] Evan Miller, Emiller‘s Guide To Nginx Module Development.<a href="http://www.evanmiller.org/nginx-modules-guide.html" rel="external nofollow noreferrer">http://www.evanmiller.org/nginx-modules-guide.html</a>, 2009</p>
<p>[2]&nbsp;<a href="http://wiki.nginx.org/Configuration" rel="external nofollow noreferrer">http://wiki.nginx.org/Configuration</a></p>
<p>[3] Cl&eacute;ment Nedelcu, Nginx Http Server. Packt Publishing, 2010</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:27:09 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>FW:  Nginx模块开发入门的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPd5jyM.html" rel="bookmark">Nginx模块开发入门（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Amx8g4.html" rel="bookmark">Nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP8gnPM.html" rel="bookmark">Nginx模块开发入门&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MENY2g0.html" rel="bookmark">&lbrack;转&rsqb; Nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核 心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz8wAW3.html" rel="bookmark">linux下nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文模块编写参考http://blog.codinglabs.org/articles/intro-of-nginx-module-development.html 之前讲了nginx的安装,算是对nginx有了最初步的了解,在配置完之后,我们就可以进行简单的nginx模块开发了. 下面本文展示一个简单的Nginx模块开发全过程,我们开发一个叫echo的handler模块,这个模块功能非常简单,它接收“echo”指令,指令可指定一个字符串参数,模块会输出这个字符串作为HTTP响应.例如,对ngi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wYZq1M.html" rel="bookmark">nginx http模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导语 本文对nginx http模块开发需要掌握的一些关键点进行了提炼,同时以开发一个简单的日志模块进行讲解,让nginx的初学者也能看完之后做到心里有谱.本文只是一个用作入门的概述. 目录 背景 主线 认识nginx http请求处理流程 日志模块开发准备 配置解析流程 挂载处理函数 获取日志数据 模块编译 完整源码 结尾 背景 网上已经有很多介绍nginx http模块开发入门的文章,但是大多以hello_word程序为例,简单讲解一下代码,看完之后可能只能够依葫芦画瓢,做不了其它事情,更不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wAkEYM.html" rel="bookmark">解剖Nginx&amp;&num;183&semi;模块开发篇（1）跑起你的 Hello World 模块！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 学习 Nginx 模块开发需要有哪些准备? 需要的预备知识不多,有如下几点: 有过一些 C 语言的编程经历: 知道 Nginx 是干嘛的,并有过编写或改写 Nginx 的配置文件的经历. OK,就这两点就够了 :) 好了,那就开始吧~ 2 我们的 HelloWorld 的目标是什么? 我们的目标,就是你在浏览器里输入http://localhost/hello_world时,显示: hello world 当然,为了能够更加自定义一些,我们尝试在hello world后面再显示一个字符串,比			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pxDZ3.html" rel="bookmark">NGINX模块开发 之 验证URL参数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:邹祁峰 邮箱:[email protected] 博客:http://blog.csdn.net/qifengzou 日期:2014.05.26 16:45 转载请注明来自&quot;祁峰&quot;的CSDN博客 要求在浏览器地址栏中输入&quot;localhost/login?user=qifeng&amp;passwd=123456&quot;,并在浏览器上显示验证结果(Success 或 Failed).以下是在NGINX中添加一个LOGIN模块的整个处理过程. 1 修改配置 修改配置文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NrbkJ4.html" rel="bookmark">Nginx模块开发&mdash;Nginx代码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.简介 基本上,Nginx所采用的是一种类似BSD的C代码风格,很规范.也很清晰.建议我们的Nginx模块开发也采用Nginx的编码风格. 2.命名方式 除宏定义外,字母均为小写,单词间用下划线(_)间隔. 3.对齐方式 代码方式是K&amp;R的对齐方式,需要注意以下几点: (1)用空格而不是tab对齐,空格数目为4个 : if (ngx_process == NGX_PROCESS_SINGLE) { ngx_single_process_cycle(cycle); } else { ngx_ma			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vZeL3.html" rel="bookmark" class="title">第二阶段冲刺第六天</a>
					<div>
						首先说一下我们小组在冲刺的第一个高峰(组内自己制定的,即一个冲刺间隔时间)内的成果. 一,界面优化的更为亲近用户. 二,蓝牙聊天功能完成,但界面还需要优化. 三,记账本功能正在进行中. 遇到的难题:在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyLnE4.html" rel="bookmark" class="title">【结构】平均分和最高分</a>
					<div>
						题目描述 输入某班5位学生的姓名及数学.英语成绩,计算每位学生的平均分:然后输出平均分最高的学生之姓名及数学.英语成绩. 输入要求 输入某班5位学生的姓名及数学.英语成绩.姓名是一个长度不超过19个字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j51pgM.html" rel="bookmark" class="title">linux上安装hbase</a>
					<div>
						1.使用hadoop账号解压到/opt/hadoop目录下: # su hadoop $ tar -zxvf hbase-${version} -C /opt/hadoop $ ln -s hbase ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rE2810.html" rel="bookmark" class="title">POJ 3522 Slim Span 最小生成树&comma;暴力 难度&colon;0</a>
					<div>
						kruskal思想,排序后暴力枚举从任意边开始能够组成的最小生成树 #include &lt;cstdio&gt; #include &lt;algorithm&gt; using namespace ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j7rPV3.html" rel="bookmark" class="title">koa中间件分析</a>
					<div>
						转载请注明: TheViper http://www.cnblogs.com/TheViper  另外可以参考http://purplebamboo.github.io/2014/05/24/koa- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGdgwM.html" rel="bookmark" class="title">js自定义日历</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta name=&quot;viewport&quot; content=&quot;wid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoarRw3.html" rel="bookmark" class="title">通用树形下拉菜单生成类</a>
					<div>
						&lt;?php /** * 通用的树型类,可以生成任何树型结构 */ class tree {     /**     * 生成树型结构所需要的2维数组     * @var array     * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODWBZ4.html" rel="bookmark" class="title">Android代码检测是debug还是release</a>
					<div>
						在开发的过程中发布和测试版本需要进行不同的处理.例如我们希望测试版本打印log信息或者是输出某些日志文件,但是正式版本不希望输出这些信息.使用版本控制的分支是一个方法.但是这样需要进行分支间合并,则比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYvlA4.html" rel="bookmark" class="title">How is Quality Score Calculated&quest;</a>
					<div>
						Google determines Quality Score slightly differently for each of the different advertising networks  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPqN74.html" rel="bookmark" class="title">基于Azure blob storage T级别HBase表恢复</a>
					<div>
						为减少Hbase集群压力,提高性能,我们将HBase库中的数据移到另外的存储,下面记录当我需要对数据进行计算时,数据恢复的过程 目录: Azure storage explorer 工具 数据复制 元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZV9z3.html" rel="bookmark" class="title">浅谈strtok</a>
					<div>
						原型:char *strtok(char *s, char *delim); 功能:分解字符串为一组标记串.s为要分解的字符串,delim为分隔符字符串. 说明:首次调用时,s必须指向要分解的字符串, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBk5b3.html" rel="bookmark" class="title">盗版升级win10黑屏解决方法</a>
					<div>
						盗版升级win10遭遇黑屏怎么解决?近日就有相关媒体报道料称,假如盗版升级Win10后,那么间隔1个小时就会出现一次黑屏--! 那么盗版Win10一小时黑屏一次有没有什么解决方案?方法很定是有的,而且 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQeOK3.html" rel="bookmark" class="title">&lbrack;转&rsqb;NHibernate之旅&lpar;8&rpar;：巧用组件之依赖对象</a>
					<div>
						本节内容 引入 方案1:直接添加 方案2:巧用组件 实例分析 结语 引入 通过前面7篇的学习,有点乏味了~~~这篇来学习一个技巧,大家一起想想如果我要在Customer类中实现一个Fullname属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgmPNL3.html" rel="bookmark" class="title">Python基础学习（第3天）</a>
					<div>
						第6课 循环 1.for 元素 in 序列: statement Python的新函数range():新建一个数列,都是整数,从0开始,下一个元素比上一个元素大1,一直到数列的上限(不包括上限).PS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnnYJM.html" rel="bookmark" class="title">ARM伪指令&comma;王明学learn</a>
					<div>
						ARM伪指令 在ARM汇编语言程序中里,有一些特殊指令助记符与指令系统的助记符不同,没有相对应的操作码,通常称这些特殊指令助记符为伪指令,他们所完成的操作称为伪操作.伪指令在元程序中的作用是为完成汇编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K1qYw4.html" rel="bookmark" class="title">实体类数据访问类</a>
					<div>
						1.在解决方案创建文件夹App_Code吧所有的数据类和实体类放到App_Code文件夹下面 实体类: 吧数据库的表抽象成程序中的类 类名=表名 属性名=列名 using System; using  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l8erN0.html" rel="bookmark" class="title">添加curl的openssl的功能，实现https的正确访问</a>
					<div>
						公司开发部遇到一个难题,服务器环境的curl的功能参数无法支持ssl,那么很多功能将会无法实现.那么好吧,这个问题只好抛到运维这边了,我也是个新手,下边的见解纯属个人分析(如有问题,欢迎讨论): 首先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDDkVnM.html" rel="bookmark" class="title">P2330 &lbrack;SCOI2005&rsqb; 繁忙的都市   洛谷</a>
					<div>
						https://www.luogu.org/problem/show?pid=2330#sub 题目描述 城市C是一个非常繁忙的大都市,城市中的道路十分的拥挤,于是市长决定对其中的道路进行改造.城市C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RLyZR4.html" rel="bookmark" class="title">移动APP测试 【3】-- 性能测试</a>
					<div>
						性能测试 移动产品的功能测试,以及功能测试的自动化,可以验证被测试产品功能层面的正确性和可用性 适用情况: App 使用的时候,卡顿 查询信息 或者 执行一个操作时, 服务端需要好久,才能响应 当 A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyzykV0.html" rel="bookmark" class="title">FTU几种保护逻辑研究</a>
					<div>
						三段式电流保护 三段式定时限过流保护其中各段动作电流定值和动作时间定值可独立设定,各段过流保护都采用相同的动作判别逻辑,动作出口条件为: 为第N段电流定值 三段保护投入 延时时间到 三段保护软压板投入 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
